import lang.stride.*;
import java.util.*;
import greenfoot.*;

/**
 * Elternklasse von Peetie. Wird für diverse Variablen + Methoden benutzt, die Peetie erbt, damit die Klasse Peetie schlank bleibt und von den Schüler/innen einfach bedient werden kann.
 */
public abstract class AI_Robot extends Actor
{
    // Werte nach Belieben ändern:
    protected int peetieStartposX = 999999; // Mitte der Welt
    protected int peetieStartposY = 999999; // unten
    protected int peetieDirection = 0; // Schaut nach Osten
    protected int delay = 40;   // Wie lange wartet Peetie zwischen einzelnen Aktionen (gehe Links, geheRechts...)
    protected int peetieGeschwindigkeit = 5; // Wie schnell bewegt sich Peetie
    // Möglich auch warten(int delay)
    protected String peetieDefaultImage = "peetie_runter_50.png";
    protected int raketenVerzoegerung = 100;
    protected int raketenVerzoegerungscounter;

    protected boolean drohneWurdeAbgeschossen = false;
    protected boolean peetieWurdeGetroffen = false;

    // Andere Variablen, nicht ändern
    protected Mars mars; // Wird in der addedToWorld-Methode initialisiert

    public AI_Robot() {
        this.setRotation(this.peetieDirection);
    }

    public void act() {
        // Wenn die act-Methode nur einmal (statt als Loop) laufen soll, folgende Zeile auskommentieren:
        this.run();
        this.peetieAufTrefferPruefen(); // nur relevant für drohnenbomben

        this.peetieAufKollisionMitDrohnePruefen();
        this.raketenVerzoegerungscounter--;
    }

    /**
     * #################### BASIS ANGREIFEN######################
     */
    public boolean basisErreicht() {
        return this.isTouching(Basis.class);
    }

    /**
     * #################### TASTATUR & FIGHT ######################
     */

    public boolean tasteGedrueckt(String t) {
        if(Greenfoot.isKeyDown(t)) {
            return true;
        } else {
            return false;
        }
    }

    public boolean leertasteGedrueckt() {
        if(Greenfoot.isKeyDown("space")) { 
            // Loading Rocket
            this.getImage().setTransparency(Greenfoot.getRandomNumber(80) + 40); 
            Sound.play("LOADING");
        } else { 
            this.getImage().setTransparency(255); } 
        String taste = Greenfoot.getKey();
            // Damit pro Abschuss nur einmal Munitionsvariablen runtergezählt werden usw.
        if(taste != null) {
            if(taste.equals("space")) return true;
        } else {
            return false;
        }
        return false;
    }
    public boolean maustasteGedrueckt() {
        return Greenfoot.mouseClicked(null);
    }
    

    public void raketeAbfeuern() {
        if(this.raketenVerzoegerungscounter <= 0 || this.getWorld().getObjects(Rakete.class).size() == 0) {
            Rakete r = new Rakete();
            Sound.play("MISSILE");
            this.getWorld().addObject(r, this.getX(), this.getY() - 25);
            this.raketenVerzoegerungscounter = this.raketenVerzoegerung; }
    }

    public boolean drohneWurdeZerstoert() {
        if(this.drohneWurdeAbgeschossen) {
            this.drohneWurdeAbgeschossen = false;
            return true;
        } else {
            return false;
        }
    }

    public void setDrohneWurdeAbgeschossen(boolean d) { // Nachricht von Weltklasse, wenn Drohne abgeschossen wurde
        this.drohneWurdeAbgeschossen = d;
    }

    public boolean peetieWurdeGetroffen() {
        if(this.peetieWurdeGetroffen) {
            this.peetieWurdeGetroffen = false;
            return true;
        } else {
            return false;
        }
    }

    private void peetieAufTrefferPruefen() {
        if(this.isTouching(Drohnenbombe.class)) {
            GreenfootImage bildAlt = this.getImage();
            int rotation = this.getRotation();
            this.peetieWurdeGetroffen = true;
            this.setImage("peetie_runter_50_verformt.png");
            this.setRotation(0);
            Sound.play("SMALLHIT");
            this.warten(8);
            this.setImage(bildAlt);
            this.setRotation(rotation);
            this.removeTouching(Drohnenbombe.class);
        }
    }

    private void peetieAufKollisionMitDrohnePruefen() {
        if(this.isTouching(Gegner.class)) {
            this.setImage("explosiongelb_100.png");
            this.systemnachricht("Peetie wurde von einer Drohne gerammt! #FAIL");
            Sound.play("EXPLOSION");

            Greenfoot.stop();
        }
    }

    /*
     * #################### TEXT EINLESEN / AUSGEBEN ######################
     */
    public String textEinlesen() {
        return Greenfoot.ask("");
    }

    public double zahlEinlesen() {
        return Double.parseDouble(this.textEinlesen());
    }

    public void ausgabe(String text) {
        this.tAusgeben(text);
    }

    public void ausgabe(int text) {
        this.tAusgeben(Integer.toString(text));
    }

    public void ausgabe(double text) {
        this.tAusgeben(Double.toString(text));
    }

    private void tAusgeben(String t) {
        GreenfootImage g = new GreenfootImage(t, 20, Color.WHITE, Color.RED);
        Label l = new Label();
        l.setImage(g);
        this.getWorld().addObject(l, this.getWorld().getWidth(),200);
        for(int x = this.getWorld().getWidth(); x >= this.getWorld().getWidth()/2; x = x - 15) {
            l.setLocation(x, l.getY());
            this.warten(1);
        }
        Sound.play("BING");
        this.warten(200);
        for(int x = this.getWorld().getWidth()/2; x >= 0; x = x - 15) {
            l.setLocation(x, l.getY());
            this.warten(1);
        }
        this.getWorld().removeObject(l);
    }

    public void textAusgeben(String t, int x, int y) {
        this.getWorld().showText(t, x, y);
    }

    public void textAusgeben(int t, int x, int y) {
        this.getWorld().showText(Integer.toString(t), x, y);
    }

    private void systemnachricht(String t) {
        this.getWorld().showText(t, this.getWorld().getWidth()/2, this.getWorld().getHeight()/2);
    }

    /* #################### BEWEGEN ######################
     */
    public void geheRechts() {
        this.bewegen(0, "peetie_rechts_50.png", 0, "STEP1"); 
    }

    public void geheLinks() {
        this.bewegen(180, "peetie_links_50.png", 180, "STEP2"); 
    }

    public void geheHoch() {
        this.bewegen(270, "peetie_hoch_50.png", 90, "STEP3"); 
    }

    public void geheRunter() {
        this.bewegen(90, "peetie_runter_50.png", 270, "STEP4"); 
    }

    /* 
     * #########################################################
     * #########################################################
     * ################# PRIVATE METHODEN ######################
     * #########################################################
     * #########################################################
     * werden von Standard-Methoden benutzt
     * werden aber von Schüler/innen nicht benutzt 
     * 
     */
    private void bewegen(int neueAusrichtung, String neuesBild, int bildRotation, String sound) {
        this.setRotation(neueAusrichtung);
        this.setImage(neuesBild);
        this.getImage().rotate(bildRotation);
        this.move(this.peetieGeschwindigkeit);
    }

    /* SETUP-/INITIALIZE-functions */
    public void addedToWorld(World w) {
        this.startpositionEinnehmen(w);
        this.mars = (Mars)w;
    }

    public void startpositionEinnehmen(World w) {
        this.peetieStartposX = this.getWorld().getWidth()/2;
        this.peetieStartposY = this.getWorld().getHeight() - 50;
        this.setLocation(this.peetieStartposX, this.peetieStartposY);
        this.setImage(this.peetieDefaultImage);
    }

    /* Andere Methoden, die Schüler/innen nicht brauchen: */
    public void run() {
        // Wird in Peetie überschrieben
    }

    private void warten() {
        Greenfoot.delay(this.delay);
    }

    private void warten(int del) {
        Greenfoot.delay(del);
    }
}
